// Generated by CoffeeScript 1.9.1
(function() {
  var BodyEmptyError, HashRing, NotImplemented, RequestRateLimiter, Spider, StatusCodeError, _, cheerio, co, debug, events, limiter,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  events = require('events');

  co = require('co');

  RequestRateLimiter = require('request-rate-limiter');

  cheerio = require('cheerio');

  debug = require('debug')('cw:spider');

  HashRing = require('hashring');

  limiter = require('co-limiter');

  _ = require('lodash');

  StatusCodeError = (function(superClass) {
    extend(StatusCodeError, superClass);

    function StatusCodeError(params1, statusCode) {
      this.params = params1;
      this.statusCode = statusCode;
      StatusCodeError.__super__.constructor.call(this, "id=" + this.params + ", statusCode=" + this.statusCode);
    }

    return StatusCodeError;

  })(Error);

  BodyEmptyError = (function(superClass) {
    extend(BodyEmptyError, superClass);

    function BodyEmptyError(params1) {
      this.params = params1;
      BodyEmptyError.__super__.constructor.call(this, "id=" + this.params + ", result.body is null");
    }

    return BodyEmptyError;

  })(Error);

  NotImplemented = (function(superClass) {
    extend(NotImplemented, superClass);

    function NotImplemented(methodName1) {
      this.methodName = methodName1;
      NotImplemented.__super__.constructor.call(this, "[" + methodName + "] not implemented");
    }

    return NotImplemented;

  })(Error);

  Spider = (function(superClass) {
    extend(Spider, superClass);

    function Spider(options1) {
      this.options = options1;
      this._initialize(this.options);
      Spider.__super__.constructor.apply(this, arguments);
    }

    Spider.prototype._initialize = function(options1) {
      var options;
      this.options = options1;
      options = {
        co: {
          limt: 3
        },
        rate: {
          rate: 60,
          interval: 30,
          backoffCode: 429,
          backoffTime: 10,
          maxWaitingTime: 300
        },
        request: {
          timeout: 5000,
          maxSockets: 10
        }
      };
      this.options = _.merge(options, this.options);
      this.requestRateLimiter = new RequestRateLimiter(this.options.rate);
      this.ring = new HashRing;
      return this.limit = limiter(this.options.co.limt);
    };

    Spider.prototype.mapUrl = function(params) {
      debug("[mapUrl]:" + params);
      throw new NotImplemented('mapUrl');
    };

    Spider.prototype.addProxy = function(server) {
      debug("[addProxy] -> " + server);
      return this.ring.add(server);
    };

    Spider.prototype.removeProxy = function(server) {
      debug("[removeProxy] -> " + server);
      return this.ring.remove(server);
    };

    Spider.prototype._getProxy = function(key) {
      return this.ring.get(key);
    };

    Spider.prototype.parse = function(params, $, result) {
      throw new NotImplemented('perform');
    };

    Spider.prototype.save = function(data) {
      debug("[save] -> " + data);
      throw new NotImplemented('save');
    };

    Spider.prototype._task = function*(params) {
      var $, data, options, proxy, ref, result, url;
      url = this.mapUrl(params);
      debug("[Fetching] -> " + url);
      proxy = this._getProxy(url);
      debug("[GetProxyAddress] -> " + proxy);
      options = _.merge({
        url: url,
        proxy: proxy
      }, this.options.request);
      result = (yield this.requestRateLimiter.request(options));
      debug("[HTTPResponse] -> (" + params + ") statusCode", result.statusCode);
      debug("[HTTPResponse] -> (" + params + ") body.length", (ref = result.body) != null ? ref.length : void 0);
      if (result.statusCode !== 200) {
        throw new StatusCodeError(params, result != null ? result.statusCode : void 0);
      }
      if (!result.body) {
        throw new BodyEmptyError(params);
      }
      $ = cheerio.load(result.body);
      data = this.parse(params, $, result);
      return this.save(data);
    };

    Spider.prototype.start = function(paramsList) {
      var i, len, params, results;
      results = [];
      for (i = 0, len = paramsList.length; i < len; i++) {
        params = paramsList[i];
        results.push(co((function(_this) {
          return function*() {
            return (yield _this.limit(_this._task(params)));
          };
        })(this))["catch"]((function(_this) {
          return function(error) {
            debug("[Error] ->", error);
            return _this.emit('error', error);
          };
        })(this)));
      }
      return results;
    };

    return Spider;

  })(events.EventEmitter);

  module.exports = {
    StatusCodeError: StatusCodeError,
    BodyEmptyError: BodyEmptyError,
    NotImplemented: NotImplemented,
    Spider: Spider
  };

}).call(this);
